/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License, Version 1.0 only
 * (the "License").  You may not use this file except in compliance
 * with the License.
 *
 * You can obtain a copy of the license at http://smartos.org/CDDL
 *
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file.
 *
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 *
 *
 * Copyright 2016, Joyent, Inc.
 *
 *
 * onlyif utility
 */

var os = require('os');

var zone = require('/usr/node/node_modules/zonename');

/*
 * Example:
 *
 * onlyif.rootInSmartosGlobal(function(err) {
 *     if (err) {
 *         console.log('Fatal: cannot run because: ' + err);
 *         process.exit(1);
 *     }
 *     console.log('hello root in the GZ!');
 * });
 *
 */

exports.rootInSmartosGlobal = function (callback)
{
    if (process.getuid() !== 0) {
        callback('you are not root.');
        return;
    }

    if (os.type() !== 'SunOS') {
        callback('this is not SmartOS.');
        return;
    }

    if (zone.getzonename() !== 'global') {
        callback('this is not the global zone.');
        return;
    }

    callback();
};
